<?php

namespace App\Exports;

use App\Models\DailyStockRecord;
use App\Models\Log;
use App\Utils\ArrayUtils;
use App\Utils\DateTimeUtils;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use App\Models\GoodsSku;
use Illuminate\Support\Collection;

class GoodsSkusExport implements FromCollection, ShouldAutoSize
{
    private $data;
    private $type;

    public function __construct($type)
    {
        $this->type = $type;
        $this->data = $this->createData();
    }

    /**
     * @return \Illuminate\Support\Collection
     */
    public function collection()
    {
        return new Collection($this->data);
    }

    private function createData()
    {
        $headTitle = [
            '商品编码',
            '商品名称',
            '商品种类',
            '商品品牌',
            '规格编码',
            '规格名称',
        ];
        $map = [
            'cost' => ['成本', '更新前成本', '更新后成本'],
            'inventory' => ['库存', '盘点', '上新'],
        ];
        $headTitle = array_merge($headTitle, $map[$this->type]);
        if ('cost' === $this->type) {
            $update = $this->getChangeCostLogs();
        }
        if ('inventory' === $this->type) {
            $update = $this->getInventoryRecord();
        }
        $ids = array_keys($update);
        if (empty($ids)) {
            return [$headTitle];
        }
        $model = GoodsSku::query()
            ->when($ids, function ($query, $ids) {
                return $query->whereIn('id', $ids);
            })
            ->with(['goods' => function ($query) {
                $query->with(['type:id,name', 'brand:id,name'])
                    ->orderBy('type_id')
                    ->orderBy('brand_id');
            }]);
        $data = $model->get()->toArray();
        if (empty($data)) {
            return [$headTitle];
        }
        $bodyData = [];
        foreach ($data as $item) {
            $arr[0] = $item['goods']['goods_code'];
            $arr[1] = $item['goods']['title'];
            $arr[2] = $item['goods']['type']['name'];
            $arr[3] = $item['goods']['brand']['name'];
            $arr[4] = $item['sku_code'];
            $arr[5] = $item['title'];
            if ('cost' === $this->type) {
                $arr[6] = (string)$item['cost'];
                $arr[7] = (string)$update[$item['id']]['before_update'];
                $arr[8] = (string)$update[$item['id']]['after_update'];
            }
            if ('inventory' === $this->type) {
                $arr[6] = (string)$item['stock'];
                $arr[7] = (string)$update[$item['id']]['inventory'];
                $arr[8] = (string)$update[$item['id']]['arrived_today_num'];
            }
            $bodyData[] = $arr;
        }
        unset($arr);
        return [$headTitle, $bodyData];
    }

    private function getChangeCostLogs()
    {
        $day = DateTimeUtils::getToday();
        $logs = Log::query()
            ->select(['target_id', 'before_update', 'after_update'])
            ->where('target_type', 'goods_sku')
            ->where('target_field', 'cost')
            ->where('created_at', '>', $day)
            ->orderBy('id', 'asc')
            ->get();
        $update = [];
        foreach ($logs as $log) {
            if ($log['before_update'] !== $log['after_update'] || (int)$log['after_update']) {
                if (!isset($update[$log['target_id']])) {
                    $update[$log['target_id']]['before_update'] = $log['before_update'];
                }
                $update[$log['target_id']]['after_update'] = $log['after_update'];
            }
        }

        return $update;
    }

    private function getInventoryRecord()
    {
        $day = date('Y-m-d', strtotime('-1 day'));
        $records = DailyStockRecord::query()
            ->select(['sku_id', 'inventory', 'arrived_today_num'])
            ->where('day', $day)
            ->where(function ($query) {
                $query->where('arrived_today_num', '<>', 0)
                    ->orWhere('inventory', '<>', 0);
            })
            ->get()
            ->toArray();

        return ArrayUtils::index($records, 'sku_id');
    }
}
